/*Ŀ
                                                                          
    SS 1.0                                                                
                                                                          
    Programa de compresso e descompresso de dados.                      
                                                                          
  Ĵ
                                                                          
    Copyright (c) Firix Software Development                              
    All Rights Reserved.                                                  
                                                                          
  */

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define N            4096   
#define F            18   
#define THRESHOLD    2   
#define NIL          N    

unsigned long int textsize = 0;
unsigned long int codesize = 0;
unsigned long int printcount = 0; 
unsigned char text_buf[N + F - 1];    
int match_position;
int match_length;
int lson[N + 1];
int rson[N + 257];
int dad[N + 1];
int output = 0;
FILE *infile;
FILE *outfile;


void InitTree(void)                                      // inicializa rvore
{
  int  i;

  for (i = N + 1; i <= N + 256; i++)
    rson[i] = NIL;
  for (i = 0; i < N; i++)
    dad[i] = NIL;
}

void InsertNode(int r)
{
  int  i, p, cmp;
  unsigned char  *key;

  cmp = 1;
  key = &text_buf[r];
  p = N + 1 + key[0];
  rson[r] = lson[r] = NIL;
  match_length = 0;
  for ( ; ; ) {
    if (cmp >= 0) {
      if (rson[p] != NIL)
        p = rson[p];
       else
       {
         rson[p] = r;
         dad[r] = p;
         return;
       }
    }
     else
     {
       if (lson[p] != NIL)
         p = lson[p];
        else
        {
          lson[p] = r;
          dad[r] = p;
          return;
        }
     }
    for (i = 1; i < F; i++)
      if ((cmp = key[i] - text_buf[p + i]) != 0)
        break;
    if (i > match_length) {
      match_position = p;
      if ((match_length = i) >= F)
        break;
    }
  }
  dad[r] = dad[p];
  lson[r] = lson[p];
  rson[r] = rson[p];
  dad[lson[p]] = r;
  dad[rson[p]] = r;
  if (rson[dad[p]] == p)
    rson[dad[p]] = r;
   else
    lson[dad[p]] = r;
  dad[p] = NIL;                                                   // remove p
}

void DeleteNode(int p)  
{
  int  q;
	
  if (dad[p] == NIL)
    return;
  if (rson[p] == NIL)
    q = lson[p];
   else
    if (lson[p] == NIL)
      q = rson[p];
     else
     {
       q = lson[p];
       if (rson[q] != NIL) {
         do {
           q = rson[q];
         } while (rson[q] != NIL);
         rson[dad[q]] = lson[q];
         dad[lson[q]] = dad[q];
         lson[q] = lson[p];
         dad[lson[p]] = q;
       }
       rson[q] = rson[p];  dad[rson[p]] = q;
     }
  dad[q] = dad[p];
  if (rson[dad[p]] == p)
    rson[dad[p]] = q;
   else
    lson[dad[p]] = q;
  dad[p] = NIL;
}

void Encode(void)
{
  int  i, c, len, r, s, last_match_length, code_buf_ptr;
  unsigned char  code_buf[17], mask;

  printf("\n");
  InitTree();
  code_buf[0] = 0;  
  code_buf_ptr = mask = 1;
  s = 0;
  r = N - F;
  for (i = s; i < r; i++)
    text_buf[i] = ' ';
  for (len = 0; len < F && (c = getc(infile)) != EOF; len++)
    text_buf[r + len] = c;
  if ((textsize = len) == 0)
    return;
  for (i = 1; i <= F; i++)
    InsertNode(r - i);
  InsertNode(r);
  do {
    if (match_length > len)
      match_length = len;
    if (match_length <= THRESHOLD) {
      match_length = 1;  
      code_buf[0] |= mask; 
      code_buf[code_buf_ptr++] = text_buf[r];  
    }
     else
     {
       code_buf[code_buf_ptr++] = (unsigned char) match_position;
       code_buf[code_buf_ptr++] = (unsigned char)
                                  (((match_position >> 4) & 0xf0)
                                  | (match_length - (THRESHOLD + 1)));  
     }
    if ((mask <<= 1) == 0) {  
      for (i = 0; i < code_buf_ptr; i++)  
        putc(code_buf[i], outfile);    
      codesize += code_buf_ptr;
      code_buf[0] = 0;  code_buf_ptr = mask = 1;
    }
    last_match_length = match_length;
    for (i = 0; i < last_match_length && (c = getc(infile)) != EOF; i++) {
      DeleteNode(s);    
      text_buf[s] = c;      
      if (s < F - 1)
        text_buf[s + N] = c;
      s = (s + 1) & (N - 1);
      r = (r + 1) & (N - 1);
      InsertNode(r);  
    }
    if ((textsize += i) > printcount) {
      if (output == 0) 
        cprintf("%12ld\r", textsize);
      printcount += 1024;
    }
    while (i++ < last_match_length) {    
      DeleteNode(s);                                
      s = (s + 1) & (N - 1);
      r = (r + 1) & (N - 1);
      if (--len)
        InsertNode(r);
    }
  } while (len > 0);    
  if (code_buf_ptr > 1) {       
    for (i = 0; i < code_buf_ptr; i++)
      putc(code_buf[i], outfile);
    codesize += code_buf_ptr;
  }
  if (output == 0) {
    cprintf("Entrada       : %ld bytes\n\r", textsize);
    cprintf("Sada         : %ld bytes\n\r", codesize);
    cprintf("Entrada/Sada : %.3f\r", (double)codesize / textsize);
  }
}

void Decode(void)     
{
  int  i, j, k, r, c;
  unsigned int  flags;

  cprintf("\n\rDescompactando ...\r");
  for (i = 0; i < N - F; i++)
    text_buf[i] = ' ';
  r = N - F;  flags = 0;
  for ( ; ; ) {
    if (((flags >>= 1) & 256) == 0) {
      if ((c = getc(infile)) == EOF)
        break;
      flags = c | 0xff00;        
    }     
    if (flags & 1) {
      if ((c = getc(infile)) == EOF)
        break;
      putc(c, outfile);
      text_buf[r++] = c;
      r &= (N - 1);
    }
     else
     {
       if ((i = getc(infile)) == EOF)
         break;
       if ((j = getc(infile)) == EOF)
         break;
       i |= ((j & 0xf0) << 4);
       j = (j & 0x0f) + THRESHOLD;
       for (k = 0; k <= j; k++) {
         c = text_buf[(i + k) & (N - 1)];
         putc(c, outfile);
         text_buf[r++] = c;
         r &= (N - 1);
       }
     }
  }
}

int main(int argc, char *argv[])
{
  char  *s;

  if (argc < 4) {                           // no tem parmetros suficientes
    textcolor(9);
    cprintf("\n\rSS 1.0\n\r");
    textcolor(2);
    cprintf("Copyright (c) Firix Software Development\n\r\n\r");
    textcolor(14+128);
    cprintf("Modo de Utilizao:\n\r");
    textcolor(3);
    cprintf("\n\r  ss [e | d] file1 file2 [o]\n\r");
    cprintf("\n\r  e    compacta file1 para file2\n\r");
    cprintf("  d    descompacta file1 para file2\n\r");
    cprintf("  o    no produz output para o cran\r");
    return EXIT_FAILURE;
  }
  if ((s = argv[1], s[1] || strpbrk(s, "DEde") == NULL)
     || (s = argv[2], (infile  = fopen(s, "rb")) == NULL)
     || (s = argv[3], (outfile = fopen(s, "wb")) == NULL)) {
    textcolor(9);
    cprintf("\n\rSS 1.0\n\r");
    textcolor(2);
    cprintf("Copyright (c) Firix Software Development\n\r\n\r");
    textcolor(14+128);
    cprintf("Ficheiro '%s' no foi encontrado\r", s);
    return EXIT_FAILURE;
  }
  if (toupper(*argv[4]) == 'O') {
    textcolor(0);
    output = 1;
  }
   else
   {
     textcolor(9);
     cprintf("\n\rSS 1.0\n\r");
     textcolor(2);
     cprintf("Copyright (c) Firix Software Development\n\r");
     textcolor(3);
   }  
  if (toupper(*argv[1]) == 'E')
    Encode();
   else
    Decode();
  fclose(infile);
  fclose(outfile);
  return EXIT_SUCCESS;
}

//--- fim de ss.c -----------------------------------------------------------
